using System;
using System.IO;
using System.Text;
using System.Diagnostics;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using ComTypes = System.Runtime.InteropServices.ComTypes;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using IE = Interop.SHDocVw;
using AddinExpress.IE;
 
namespace HttpMonitor
{
    /// <summary>
    /// Add-in Express for Internet Explorer Module
    /// </summary>
    [ComVisible(true), Guid("37F03999-F3C6-409F-9164-B58F82369871")]
    public class IEModule : AddinExpress.IE.ADXIEModule
    {
        private bool newPageOpenned = false;
        private bool navigationStarted = false;
        private List<DataEntry> entries = null;
        private string previousBrowserLocation = String.Empty;
        private bool urlRequested = false;

        private const int WM_USER = 0x0400;
        private const int WM_SHOWDATA = WM_USER + 500;
        private const uint HTTP_QUERY_COOKIE = 44;
        private const uint HTTP_QUERY_SET_COOKIE = 43;
        private const uint HTTP_QUERY_RAW_HEADERS_CRLF = 22;
        private const uint HTTP_QUERY_FLAG_REQUEST_HEADERS = 0x80000000;
        private const uint HTTP_QUERY_REQUEST_METHOD = 45;


        private const uint INTERNET_OPTION_REQUEST_FLAGS = 23;
        private const uint INTERNET_REQFLAG_CACHE_WRITE_DISABLED = 0x00000040;
        private const uint INTERNET_REQFLAG_FROM_CACHE = 0x00000001;

        [DllImport("kernel32.dll", CharSet = CharSet.Auto)]
        private static extern IntPtr GlobalLock(IntPtr hMem);

        [DllImport("kernel32.dll", CharSet = CharSet.Auto)]
        private static extern bool GlobalUnlock(IntPtr hMem);

        public IEModule()
        {
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }

        private ADXIEAdvancedBarsManager monitorBarManager;
        private ADXIEAdvancedBarItem monitorBarItem;
 
        public IEModule(IContainer container)
        {
            container.Add(this);
 
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(IEModule));
            this.monitorBarManager = new AddinExpress.IE.ADXIEAdvancedBarsManager(this.components);
            this.monitorBarItem = new AddinExpress.IE.ADXIEAdvancedBarItem(this.components);
            // 
            // monitorBarManager
            // 
            this.monitorBarManager.ActiveBottomLayout = ((AddinExpress.IE.ADXIEAdvancedBarsManager.LayoutInfo)(resources.GetObject("monitorBarManager.ActiveBottomLayout")));
            this.monitorBarManager.ActiveLeftLayout = ((AddinExpress.IE.ADXIEAdvancedBarsManager.LayoutInfo)(resources.GetObject("monitorBarManager.ActiveLeftLayout")));
            this.monitorBarManager.ActiveRightLayout = ((AddinExpress.IE.ADXIEAdvancedBarsManager.LayoutInfo)(resources.GetObject("monitorBarManager.ActiveRightLayout")));
            this.monitorBarManager.ActiveTopLayout = ((AddinExpress.IE.ADXIEAdvancedBarsManager.LayoutInfo)(resources.GetObject("monitorBarManager.ActiveTopLayout")));
            this.monitorBarManager.Bars.Add(this.monitorBarItem);
            this.monitorBarManager.BrowserState = AddinExpress.IE.tagREADYSTATE.READYSTATE_UNINITIALIZED;
            this.monitorBarManager.IsKeyboardLayoutChanging = false;
            this.monitorBarManager.KeyboardLocked = true;
            this.monitorBarManager.SplitterModeActive = false;
            // 
            // monitorBarItem
            // 
            this.monitorBarItem.AllowDragDrop = false;
            this.monitorBarItem.ApplyChangesForAllTabs = true;
            this.monitorBarItem.BarObj = null;
            this.monitorBarItem.BarType = "HttpMonitor.HttpMonitorForm";
            this.monitorBarItem.Id = "{207F289F-5C73-436E-AFA3-33350AA18195}";
            this.monitorBarItem.Layout = AddinExpress.IE.ADXIEAdvancedBarLayout.Bottom;
            this.monitorBarItem.MenuText = "Http Monitor Example";
            // 
            // IEModule
            // 
            this.LoadInMainProcess = false;
            this.ModuleName = "Http Monitor";
            this.BeforeNavigate2 += new AddinExpress.IE.ADXIEBeforeNavigate2_EventHandler(this.IEModule_BeforeNavigate2);
            this.NavigateComplete2 += new AddinExpress.IE.ADXIENavigateComplete2_EventHandler(this.IEModule_NavigateComplete2);
            this.OnConnect += new AddinExpress.IE.ADXIEConnect_EventHandler(this.IEModule_OnConnect);
            this.OnSendMessage += new AddinExpress.IE.ADXIESendMessage_EventHandler(this.IEModule_OnSendMessage);
            this.DocumentComplete2 += new AddinExpress.IE.ADXIEDocumentComplete2_EventHandler(this.IEModule_DocumentComplete2);
            this.OnRequest += new AddinExpress.IE.ADXIERequest_EventHandler(this.IEModule_OnRequest);
            this.OnResponse += new AddinExpress.IE.ADXIEResponse_EventHandler(this.IEModule_OnResponse);
            this.OnReportProgress += new AddinExpress.IE.ADXIEReportProgress_EventHandler(this.IEModule_OnReportProgress);
            this.OnReportResult += new AddinExpress.IE.ADXIEReportResult_EventHandler(this.IEModule_OnReportResult);
            this.OnDataAvailable += new AddinExpress.IE.ADXIEDataAvailable_EventHandler(this.IEModule_OnDataAvailable);

        }
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void RegisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.RegisterIEModuleInternal(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void UnregisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.UnregisterIEModuleInternal(t);
        }
 
        [ComVisible(true)]
        public class IECustomContextMenuCommands :
            AddinExpress.IE.ADXIEModule.ADXIEContextMenuCommandDispatcher
        {
        }
 
        [ComVisible(true)]
        public class IECustomCommands :
            AddinExpress.IE.ADXIEModule.ADXIECommandDispatcher
        {
        }
 
        #endregion
 
        public IE.WebBrowser IEApp
        {
            get
            {
                return (this.IEObj as IE.WebBrowser);
            }
        }
 
        public mshtml.HTMLDocument HTMLDocument
        {
            get
            {
                return (this.HTMLDocumentObj as mshtml.HTMLDocument);
            }
        }

        internal class DataEntry
        {
            public string Url = String.Empty;
            public string RedirectedUrl = String.Empty;
            public string DataType = String.Empty;
            public string DataText = String.Empty;
            public string Method = String.Empty;
            public string PostDataText = String.Empty;
            public byte[] PostData = null;
            public DataEntry RefEntry = null;
        }

        private bool IsMonitorActive
        {
            get
            {
                if (monitorBarItem.BarObj != null && monitorBarItem.BarObj.Visible)
                    return true;
                return false;
            }
        }

        private HttpMonitorForm MonitorForm
        {
            get
            {
                return monitorBarItem.BarObj as HttpMonitorForm;
            }
        }

        private void IEModule_OnConnect(object sender, int threadId)
        {
            this.entries = new List<DataEntry>();
        }

        private void IEModule_BeforeNavigate2(ADXIEBeforeNavigate2EventArgs e)
        {
            if (e.PDisp == IEApp && (!String.IsNullOrEmpty((string)e.Url)))
            {
                this.navigationStarted = true;
                this.urlRequested = false;

                if (IsMonitorActive)
                {
                    if (!MonitorForm.IsSameLocation((string)e.Url))
                        this.entries.Clear();
                }
            }
        }

        private void IEModule_NavigateComplete2(ADXIENavigateComplete2EventArgs e)
        {
            if ((e.PDisp == IEApp) && this.navigationStarted)
            {
                this.navigationStarted = false;

                if (IsMonitorActive)
                {
                    if (!this.urlRequested)
                        MonitorForm.ClearData(true);

                    if (!MonitorForm.IsSameLocation(e.Url))
                        this.newPageOpenned = true;
                }
            }
        }

        private void IEModule_DocumentComplete2(object pDisp, string url, bool rootDocLoaded)
        {
            if (IsMonitorActive)
            {
                if (rootDocLoaded && this.navigationStarted)
                {
                    this.navigationStarted = false;
                    if (!MonitorForm.IsSameLocation(url))
                        this.newPageOpenned = true;
                }

                bool refresh = 
                    MonitorForm.UpdateInfo(this.entries, this.newPageOpenned);

                if (refresh)
                    SendMessage(WM_SHOWDATA, IntPtr.Zero, IntPtr.Zero);
            }

            this.newPageOpenned = false;
        }

        private Encoding GetEncoding(ADXIEBindInfoOptions options, ADXIEBICodepage codepage)
        {
            if ((options & ADXIEBindInfoOptions.EnableUTF8) > 0)
                return Encoding.UTF8;

            switch (codepage)
            {
                case ADXIEBICodepage.UTF7:
                    return Encoding.UTF7;
                case ADXIEBICodepage.UTF8:
                    return Encoding.UTF8;
                default:
                    return Encoding.Default;
            }
        }

        private Encoding GetEncoding(ADXIEBindInfo binfo)
        {
            return GetEncoding(binfo.Options, binfo.CodePage);
        }

        private unsafe void IEModule_OnReportProgress(object sender, ADXIEReportProgressEventArgs e)
        {
            if (IsMonitorActive)
            {
                ADXIEBindFlags flags;
                string url = String.Empty;
                ADXIEBindInfo binfo = new ADXIEBindInfo();


                if (e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.Redirecting ||
                    e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.CookieSent ||
                    e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.MimeTypeAvailable ||
                    e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.CookieStateLeash ||
                    e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.CookieStateAccept ||
                    e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.CacheFileNameAvailable ||
                    e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.P3PHeader ||
                    e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.SendingRequest ||
                    e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.DownloadingData ||
                    e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.Connecting)
                {
                    url = e.GetBindString(ADXIEBindStringType.Url);
                    binfo = e.GetBindInfo(out flags);
                }

                if (e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.CookieSent)
                {
                    string cookieSent = String.Empty;
                    byte[] cookieSentBytes = e.GetQueryInfo(HTTP_QUERY_COOKIE | HTTP_QUERY_FLAG_REQUEST_HEADERS);

                    if (cookieSentBytes != null)
                        cookieSent = GetEncoding(binfo).GetString(cookieSentBytes);

                    if (!String.IsNullOrEmpty(cookieSent))
                    {
                        DataEntry entry = FindEntry("CookieSent", url, null);
                        string data = "COOKIE SENT: " + url + "\r\n" + cookieSent;

                        if (entry == null || (entry != null && entry.DataText != data))
                        {
                            DataEntry dentry = CreateEntry(url, "CookieSent");
                            dentry.DataText = data;
                        }
                    }
                }
                else if (e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.CookieStateLeash || e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.CookieStateAccept)
                {
                    string cookieRecieved = String.Empty;
                    byte[] cookieRecievedBytes = e.GetQueryInfo(HTTP_QUERY_SET_COOKIE);

                    if (cookieRecievedBytes != null)
                        cookieRecieved = GetEncoding(binfo).GetString(cookieRecievedBytes);

                    if (!String.IsNullOrEmpty(cookieRecieved))
                    {
                        DataEntry entry = FindEntry("CookieRecieved", url, null);
                        string data = "COOKIE RECIEVED: " + url + "\r\n" + cookieRecieved;

                        if (entry == null || (entry != null && entry.DataText != data))
                        {
                            DataEntry dentry = CreateEntry(url, "CookieRecieved");
                            dentry.DataText = data;
                        }
                    }
                }
                else if (e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.Redirecting)
                {
                    if ((!String.IsNullOrEmpty(url)) &&
                        (!String.IsNullOrEmpty(e.StatusText)) &&
                        IsUrl(e.StatusText) &&
                        (!e.StatusText.Equals(url, StringComparison.InvariantCultureIgnoreCase)))
                    {
                        string method = String.Empty;
                        string requestHeaders = String.Empty;

                        byte[] requestInfoBytes = e.GetQueryInfo(HTTP_QUERY_RAW_HEADERS_CRLF | HTTP_QUERY_FLAG_REQUEST_HEADERS);
                        if (requestInfoBytes != null)
                            requestHeaders = GetEncoding(binfo).GetString(requestInfoBytes);

                        if (!String.IsNullOrEmpty(requestHeaders))
                        {
                            byte[] methodBytes = e.GetQueryInfo(HTTP_QUERY_REQUEST_METHOD);
                            if (methodBytes != null)
                                method = GetEncoding(binfo).GetString(methodBytes);

                            DataEntry entry = FindEntry("Request", e.StatusText, null);
                            string data = "REQUEST: " + url + "\r\n" + "REDIRECT: " + e.StatusText + "\r\n" + requestHeaders;

                            if (entry != null)
                            {
                                entry.DataText = data;
                                entry.RedirectedUrl = e.StatusText;
                            }
                            else
                            {
                                entry = FindEntry("Request", url, e.StatusText);
                                if (entry == null)
                                {
                                    DataEntry dentry = CreateEntry(url, "Request");
                                    dentry.RedirectedUrl = e.StatusText;
                                    dentry.Method = method;
                                    dentry.DataText = data;
                                }
                                else
                                {
                                    entry.DataText = data;
                                }
                            }
                        }
                    }
                }
                else if (e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.SendingRequest)
                {
                    if (!String.IsNullOrEmpty(url))
                    {
                        byte[] postData = null;
                        string method = String.Empty;
                        string postDataText = String.Empty;
                        string requestHeaders = String.Empty;

                        byte[] requestInfoBytes = e.GetQueryInfo(HTTP_QUERY_RAW_HEADERS_CRLF | HTTP_QUERY_FLAG_REQUEST_HEADERS);

                        if (requestInfoBytes != null)
                            requestHeaders = GetEncoding(binfo).GetString(requestInfoBytes);

                        byte[] methodBytes = e.GetQueryInfo(HTTP_QUERY_REQUEST_METHOD);
                        if (methodBytes != null)
                            method = GetEncoding(binfo).GetString(methodBytes);

                        if (binfo.BindVerb == ADXIEBindVerb.Post)
                        {
                            switch (binfo.StgmedData.Tymed)
                            {
                                case ADXIETymed.IStorage:
                                    {
                                        postDataText = "Storage [not implemeted in the current version of the Http Monitor]";
                                    }
                                    break;
                                case ADXIETymed.HGlobal:
                                    if (binfo.StgmedDataSize > 0)
                                    {
                                        IntPtr pData = GlobalLock(binfo.StgmedData.Ptr);
                                        if (pData != IntPtr.Zero)
                                        {
                                            try
                                            {
                                                byte[] bytes = new byte[binfo.StgmedDataSize];
                                                Marshal.Copy(pData, bytes, 0, (int)binfo.StgmedDataSize);
                                                postDataText = GetEncoding(binfo).GetString(bytes);
                                            }
                                            finally
                                            {
                                                GlobalUnlock(binfo.StgmedData.Ptr);
                                            }
                                        }
                                    }
                                    break;
                                case ADXIETymed.IStream:
                                    {
                                        ComTypes.IStream stm =
                                            Marshal.GetTypedObjectForIUnknown(binfo.StgmedData.Ptr, typeof(ComTypes.IStream)) as ComTypes.IStream;
                                        if (stm != null)
                                        {
                                            ComTypes.STATSTG streamStat;
                                            stm.Stat(out streamStat, 0);

                                            if (streamStat.cbSize > 0)
                                            {
                                                uint cbRead = 0;

                                                byte[] bytes = new byte[streamStat.cbSize];
                                                stm.Seek(0, 0, IntPtr.Zero);
                                                stm.Read(bytes, (int)streamStat.cbSize, (IntPtr)(&cbRead));
                                                if (cbRead > 0)
                                                {
                                                    stm.Seek(0, 0, IntPtr.Zero);
                                                    postData = bytes;
                                                }
                                            }
                                        }
                                    }
                                    break;
                            }

                            if ((!String.IsNullOrEmpty(requestHeaders)) || (postData != null) || (!String.IsNullOrEmpty(postDataText)))
                            {
                                DataEntry entry = FindEntry("Request", url, null);
                                if (entry == null)
                                    entry = FindEntry("Request", null, url);

                                string data = "REQUEST: " + url + "\r\n" + requestHeaders;

                                if (entry == null)
                                {
                                    DataEntry dentry = CreateEntry(url, "Request");
                                    dentry.Method = method;
                                    dentry.DataText = data;
                                    dentry.PostDataText = postDataText;
                                    dentry.PostData = postData;
                                }
                                else 
                                {
                                    if (!String.IsNullOrEmpty(requestHeaders))
                                        entry.DataText = data;
                                    if (!String.IsNullOrEmpty(postDataText))
                                        entry.PostDataText = postDataText;
                                    if (postData != null)
                                        entry.PostData = postData;
                                }
                            }
                        }
                    }
                }
                else if (e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.MimeTypeAvailable)
                {
                    if (url != "about:blank")
                    {
                        DataEntry entry = FindEntry("MimeType", url, null);
                        string data = "MIME TYPE AVAILABLE: " + url + "\r\n" + e.StatusText;

                        if (entry == null || (entry != null && entry.DataText != data))
                        {
                            DataEntry dentry = CreateEntry(url, "MimeType");
                            dentry.DataText = data;
                        }
                    }
                }
                else if (e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.CacheFileNameAvailable)
                {
                    DataEntry entry = FindEntry("FileName", url, null);
                    string data = "Cache File Available: " + url + "\r\n" + e.StatusText;

                    if (entry == null || (entry != null && entry.DataText != data))
                    {
                        DataEntry dentry = CreateEntry(url, "FileName");
                        dentry.DataText = data;
                    }
                }
                else if (e.StatusCode == ADXIEReportProgressEventArgs.ADXIEBindStatus.P3PHeader)
                {
                    DataEntry entry = FindEntry("P3PHeader", url, null);
                    string data = "P3PHEADER: " + url + "\r\n" + e.StatusText;

                    if (entry == null || (entry != null && entry.DataText != data))
                    {
                        DataEntry dentry = CreateEntry(url, "P3PHeader");
                        dentry.DataText = data;
                    }
                }
            }
        }

        private void IEModule_OnReportResult(object sender, ADXIEReportResultEventArgs e)
        {
            if (IsMonitorActive)
            {
                if (e.Result < 0 && e.Error != 0)
                {
                    string url = e.GetBindString(ADXIEBindStringType.Url);

                    DataEntry dentry = CreateEntry(url, "Error");
                    dentry.DataText = "ERROR: " + url + "\r\n" + e.Error.ToString();
                }
            }
        }

        private void IEModule_OnRequest(object sender, ADXIERequestEventArgs e)
        {
            if (IsMonitorActive)
            {
                if (this.navigationStarted)
                    this.urlRequested = true;

                string requestHeaders = e.Headers;

                if (requestHeaders.StartsWith("GET") || requestHeaders.StartsWith("POST"))
                {
                    string method = String.Empty;

                    byte[] methodBytes = e.GetQueryInfo(HTTP_QUERY_REQUEST_METHOD);
                    if (methodBytes != null)
                        method = GetEncoding(e.Options, e.CodePage).GetString(methodBytes);

                    DataEntry entry = FindEntry("Request", null, e.Url);
                    if (entry == null)
                    {
                        entry = CreateEntry(e.Url, "Request");
                        entry.Method = method;
                        entry.DataText = "REQUEST: " + e.Url + "\r\n" + requestHeaders;
                    }
                }
            }
        }

        private void IEModule_OnResponse(object sender, ADXIEResponseEventArgs e)
        {
            if (IsMonitorActive)
            {
                DataEntry entry = FindEntry("Request", null, e.Url);
                if (entry == null)
                    entry = FindEntry("Request", e.Url, String.Empty);

                if (entry == null)
                {
                    string method = String.Empty;
                    string requestHeaders = String.Empty;

                    byte[] requestInfoBytes = e.GetQueryInfo(HTTP_QUERY_RAW_HEADERS_CRLF | HTTP_QUERY_FLAG_REQUEST_HEADERS);
                    if (requestInfoBytes != null)
                        requestHeaders = GetEncoding(e.Options, e.CodePage).GetString(requestInfoBytes);

                    if (!String.IsNullOrEmpty(requestHeaders))
                    {
                        byte[] methodBytes = e.GetQueryInfo(HTTP_QUERY_REQUEST_METHOD);
                        if (methodBytes != null)
                            method = GetEncoding(e.Options, e.CodePage).GetString(methodBytes);

                        entry = CreateEntry(e.Url, "Request");
                        entry.Method = method;
                        entry.DataText = "REQUEST: " + e.Url + "\r\n" + requestHeaders;
                    }
                }

                DataEntry dentry = FindEntry("Response", e.Url, null);
                if (dentry == null)
                    dentry = CreateEntry(e.Url, "Response");

                dentry.DataText = "RESPONSE: " + e.Url + "\r\n" + e.ResponseHeaders;
                dentry.RefEntry = entry;
                if (entry != null)
                    entry.RefEntry = dentry;
            }
        }

        private void IEModule_OnDataAvailable(object sender, ADXIEDataAvailableEventArgs e)
        {
            if (IsMonitorActive)
            {
                if ((!String.IsNullOrEmpty(e.Url)) && (e.Url != "about:blank"))
                {
                    switch (e.DataState)
                    {
                        case ADXIEDataAvailableEventArgs.ADXIEReportDataState.DataReadyForDownload:
                            e.PreviewData = true;
                            break;
                        case ADXIEDataAvailableEventArgs.ADXIEReportDataState.DataFullyAvailable:
                            if (e.Data != null && e.Data.Length > 0)
                            {
                                DataEntry entry = FindEntry("Data", e.Url, String.Empty);

                                if (entry == null)
                                {
                                    DataEntry dentry = CreateEntry(e.Url, "Data");
                                    dentry.DataText = "DATA STREAM (" + e.Data.Length.ToString() + " bytes): " + e.Url;
                                }

                            }
                            break;
                    }

                }
            }
        }

        private void IEModule_OnSendMessage(ADXIESendMessageEventArgs e)
        {
            if (e.Message == WM_SHOWDATA)
            {
                try
                {
                    this.MonitorForm.UpdateUI();
                }
                catch (Exception err)
                {
                    Trace.WriteLine(this.ModuleName + " error: " + err.Message);
                }
            }
        }

        private DataEntry CreateEntry(string url, string dataType)
        {
            DataEntry entry = new DataEntry();
            entry.Url = url;
            entry.DataType = dataType;
            this.entries.Add(entry);
            return entry;
        }

        private DataEntry FindEntry(string dataType, string url, string redirectedUrl)
        {
            if (redirectedUrl == null && url == null)
                return null;

            if (redirectedUrl == null && url != null)
            {
                foreach (DataEntry entry in this.entries)
                {
                    if ((entry.DataType == dataType) && entry.Url.Equals(url, StringComparison.InvariantCultureIgnoreCase))
                        return entry;
                }
            }
            else if (url == null && redirectedUrl != null)
            {
                foreach (DataEntry entry in this.entries)
                {
                    if ((entry.DataType == dataType) && entry.RedirectedUrl.Equals(redirectedUrl, StringComparison.InvariantCultureIgnoreCase))
                        return entry;
                }
            }
            else
            {
                foreach (DataEntry entry in this.entries)
                {
                    if ((entry.DataType == dataType) && entry.Url.Equals(url, StringComparison.InvariantCultureIgnoreCase) && entry.RedirectedUrl.Equals(redirectedUrl, StringComparison.InvariantCultureIgnoreCase))
                        return entry;
                }
            }

            return null;
        }

        private bool IsUrl(string path)
        {
            Uri result = null;
            if (!Uri.TryCreate(path, UriKind.Absolute, out result) || (result == null))
                return false;
            return (!result.IsUnc && !string.IsNullOrEmpty(result.Host));
        }

        private Dictionary<string, string> ToDictionary(string headersText)
        {
            Dictionary<string, string> dictionary = new Dictionary<string, string>();

            if (!String.IsNullOrEmpty(headersText))
            {
                string s;
                string key;
                string value;
                int index = 0;

                string[] lines = headersText.Split('\r', '\n');

                foreach (string line in lines)
                {
                    s = line.Trim();
                    if (!String.IsNullOrEmpty(s))
                    {
                        int pos = s.IndexOf(':');
                        if (pos > 0)
                        {
                            key = s.Substring(0, pos).Trim();
                            value = s.Substring(pos + 1, s.Length - (pos + 1)).Trim();
                            if ((!String.IsNullOrEmpty(key)) && (!String.IsNullOrEmpty(value)))
                                dictionary.Add(key, value);
                        }
                    }
                    index++;
                }
            }

            return dictionary;
        }

        internal void Navigate(IE.WebBrowser browser, string urlString, bool newWindow, string targetFrameName, byte[] postData, string headers, bool tabActivate)
        {
            object uRL = urlString;
            object flags = (newWindow ? 1 : (this.IEVersion >= 7 ? (targetFrameName == "_self" ? 0 : 0x0800) : 0));
            object obj4 = targetFrameName;
            object obj5 = postData;
            object obj6 = headers;

            PerformNavigate(browser, ref uRL, ref flags, ref obj4, ref obj5, ref obj6, tabActivate);
        }

        private void PerformNavigate(IE.WebBrowser browser, ref object URL, ref object flags, ref object targetFrameName, ref object postData, ref object headers, bool tabActivate)
        {
            try
            {
                if (browser == null)
                    this.IEApp.Navigate2(ref URL, ref flags, ref targetFrameName, ref postData, ref headers);
                else
                    browser.Navigate2(ref URL, ref flags, ref targetFrameName, ref postData, ref headers);
                if (tabActivate) TabActivate();
            }
            catch (COMException exception)
            {
                // Error code -2147023673: Operation was canceled by the user.
                if (exception.ErrorCode != -2147023673)
                    throw;
            }
        }

    }
}

